const mongoose = require('mongoose');
const Schema = mongoose.Schema;

const postTemplate = {
    author: String,
    body: String,
    date: Date,
}

const AD_TYPE = {
    SALE: "sale",
    RENTAL: "rental"
};

const AD_TRANSACTION_STATUS = {
    AVAILABLE: "available",
    RENTED: "rented",
    SOLD: "sold"
};

const adSchema = new Schema({
    title: String,
    type: String,
    published: Boolean,
    transactionStatus: String,
    description: String,
    price: Number,
    availabilityDate: Date,
    pictures: [{ body: Buffer, title: String }],
    questions: [{
        ...postTemplate,
        answers: [{
            ...postTemplate
        }]
    }]
});

const Ad = mongoose.model("Ad", adSchema);

module.exports = {
    AD_TYPE: AD_TYPE,
    AD_TRANSACTIONSTATUS: AD_TRANSACTIONSTATUS,
    Ad: Ad,
}